
extends _base.pug

block title
  span Non-Linear Example

block ssvg
  input.custom-input.w-100#input(type="range" value="0")
  s-svg#ssvg
    svg#svg(height="40vh" width="100%" viewbox='0 0 100 100' preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg")
      state.
        // note: test this with 'direct' transition type
        // note: set the duration to zero to directly connect the state to the input
        transition(duration="3s" timing-function='ease-in-out' type='strict')
        property(name="range" type="number" min='0' max='100')
          transform(query-selector='#rect1' values='translate(0 0); translate(80 0) rotate(90); translate(80 80) rotate(180); translate(0 80) rotate(90);translate(0 0)')
          relation(query-selector='#rect1' attribute-name='fill' values='red;green;blue;yellow;red')

          // note: same relations but with different key-times
          // note: test it with 'linear' calc-mode
          transform(query-selector='#rect2' calc-mode='discrete' key-times='0;.1;.3;.8;1' values='translate(0 0); translate(80 0) rotate(90); translate(80 80) rotate(180); translate(0 80) rotate(90);translate(0 0)')
          relation(query-selector='#rect2' attribute-name='fill' calc-mode='discrete' key-times='0;.1;.3;.8;1' values='red;green;blue;yellow;red')

      g(transform='translate(10 10)')
        g#rect1(transform="translate(0 0) rotate(-45)")
          rect(y='-5' x='-5' width="10" height="10")
          text(x='-1' fill='black' stroke='black' font-size='4') 1
        g#rect2(transform="translate(0 0) rotate(-45)")
          rect(y='-5' x='-5' width="10" height="10")
          text(x='-1' fill='black' stroke='black' font-size='4') 2

  script(src=basePath + "/dist/ssvg-engine.js")
  script.
    ssvg.plugin();
    $(document).ready(() => {
      const ssvg = $('#ssvg');
      const input = $('#input');

      input.on('input', function() {
        ssvg.get(0).setState({ range: this.value });
      });
    });
